   {$F+}
   unit mouse;
   interface
    uses dos;
    type
     cursortype=record
      x,y:integer;
      cursor:array[1..32] of word;
     end;
     cursortype2=record
      x,y:integer;
      andim:array[1..24] of longint;
      xorim:array[1..24] of longint;
     end;
     msbut=record
      x1,y1,x2,y2:word;
      but:word;
     end;
    const
     cursor0:cursortype=(x:0;y:0;cursor:(16383,8191,
       4095,2047,1023,511,255,127,1023,511,8703,24831,61695,61567,
       61567,63999,49152,40960,36864,34816,33792,33280,33024,
       34688,33792,41472,53760,37120,2304,2176,2432,1536));
     cursor1:cursortype=(x:0;y:0;cursor:(16383,8191,
       4095,2047,1023,511,255,127,1023,8703,29183,61695,
       63743,63999,65535,65535,0,16384,24576,28672,30720,31744,
       32256,30720,18432,3072,1024,1536,512,0,0,0));
     cursor2:cursortype=(x:0;y:0;cursor:(16383,8191,
       4095,2047,1023,511,255,127,1023,8703,25087,61695,
       61695,63999,65535,65535,0,16384,24576,28672,30720,31744,
       32256,30720,22528,3072,3072,1536,1536,0,0,0));
     cursor3:cursortype=(x:30;y:0;cursor:(65532,65528,
       65520,65504,65472,65408,65280,65024,65472,65412,65422,65295,
       65311,65439,65535,65535,0,2,6,14,30,62,
       126,30,18,48,32,96,64,0,0,0));
     cursor4:cursortype=(x:0;y:0;cursor:(16383,8191,
       4095,2047,1023,511,255,127,1023,8703,25087,61695,61695,
       61567,63615,63999,49152,40960,36864,34816,33792,33280,33024,
       34688,41984,53760,37376,2304,2304,2176,1408,1536));
     on=true;
     off=false;
    var
     buts:array[1..64] of msbut;
     butcount:byte;
     mx,my:word;
     msinit:boolean;
     msstatus:byte;
     msevent:integer;
     visible:boolean;
     myvis:boolean;
    function msinstalled:boolean;
    function msbutrel:integer;
    procedure msgetrel(var dx,dy:integer);
    procedure mssetpos(x,y:word);
    procedure newmsbut(px1,py1,px2,py2,pbut:word);
    procedure msgetpos(var x,y:integer);
    procedure msgetbut(var buts:byte);
    procedure mswindow(x1,y1,x2,y2:word);
    procedure setcurs(var curs:cursortype);
    procedure getpos(var x,y:integer);
    procedure msgetofs(var ofsx,ofsy:integer);
    procedure mssetk(k:word);
    procedure mssetk2(kx,ky:word);
{    procedure msinitsys;}
    procedure msclose;
    procedure msshow;
    procedure mshide;
    procedure putcurs(fl:boolean);
   implementation
    var
    saveim:array[1..24] of longint;
    saveint1c:pointer;
    flag:boolean;
    regs:registers;
    xs,ys:word;
    function msinstalled;
     var
      n:word;
     begin
      n:=5;
      asm
       mov ax,0
       int 33h
       mov n,ax
      end;
      writeln(n);
      msinstalled:=(n=0);
     end;
    function msbutrel;
     var
      b,n:word;
     begin
      asm
       cli
       mov b,1
       mov ax,5
       int 33h
       mov b,bx
       sti
      end;
      if b>0 then n:=1 else n:=0;
      asm
       cli
       mov b,2
       mov ax,6
       int 33h
       mov b,bx
       sti
      end;
      if b>0 then n:=n or 2;
      msbutrel:=n;
     end;
    procedure msintr;
     begin
      inline($fa);
      intr($33,regs);
      inline($fb);
     end;
    procedure putcurs;
     begin
     end;
    procedure mssetk;
     begin
      asm
       mov ax,15
       mov cx,k
       mov dx,k
       int 33h
      end;
     end;
    procedure mssetk2;
     begin
      asm
       mov ax,15
       mov cx,kx
       mov dx,ky
       int 33h
      end;
     end;
    procedure msgetrel;
     var
      i,j:integer;
     begin
      asm
       mov ax,11
       int 33h
       mov i,cx
       mov j,dx
      end;
      dx:=i;
      dy:=j;
     end;
    procedure msgetofs;
     var
      ox,oy:integer;
     begin
     asm
      cli
      mov ax,11
      int 33h
      mov ox,cx
      mov oy,dx
      sti
     end;
      ofsx:=ox;
      ofsy:=oy;
     end;
    procedure setcurs;
     var
      s,o:word;
      xc,yc:integer;
     begin
       s:=seg(curs.cursor);
       o:=ofs(curs.cursor);
       xc:=curs.x;
       yc:=curs.y;
       asm
        mov ax,s
        mov es,ax
        mov ax,9
        mov dx,o
        mov bx,xc
        mov cx,yc
        int 33h
       end;
     end;
{    procedure bodyint;
     begin
      flag:=false;
      getpos(mx,my);
      msgetbut(b);
      for i:=1 to butcount do
       with buts[] do begin
        if (xm>x1) and (xm<x2) and (ym>y1) and (ym<y2)
        and (b>0)  then msevent:=i; end;
     end;
    procedure IntHandler1C; interrupt;
      var xm,ym,i:word;
       b:byte;
     begin
      if flag then bodyint;
      if saveint1c<>nil then
       inline($9c/$3e/$ff/$1e/saveint1c);
     end;}
    procedure mswindow;
     begin
      asm
       mov ax,07
       mov cx,x1
       mov dx,x2
       int 33h
       mov ax,08
       mov cx,y1
       mov dx,y2
       int 33h
      end;
     end;
    procedure mserror(error:byte);
     begin
      case error of
       1:writeln('  祭');
       2:writeln('誮  ');
      end;
     end;
{    procedure msinitsys;
     begin
      flag:=true;
      getintvec($1c,saveint1c);
      setintvec($1c,@Inthandler1c);
     end;}
    procedure msclose;
     begin
      setintvec($1c,saveint1c);
     end;
    procedure msshow;
     begin
      if not visible then begin
      regs.ax:=1;
      msintr;
      visible:=on;
      end;
     end;
    procedure mshide;
     begin
      if visible then begin
      regs.ax:=2;
      msintr;
      visible:=off;
      end;
     end;
    procedure newmsbut;
     begin
      butcount:=butcount+1;
      if butcount<64 then begin
      with buts[butcount] do begin
       x1:=px1; x2:=px2;
       y1:=py1; y2:=py2; but:=pbut;
      end; end else msstatus:=1;
     end;
    procedure msgetpos;
     var
      i,j:word;
     begin
      asm
       cli
       mov ax,3
       int 33h
       mov i,cx
       mov j,dx
       sti
      end;
      x:=i; y:=j;
     end;
    procedure  mssetpos;
     begin
     with regs do begin
      ax:=4;
      cx:=x;
      dx:=y;
      msintr; end;
     end;
    procedure msgetbut;
     begin
      regs.ax:=3;
      msintr;
      buts:=lo(regs.bx);
     end;
    procedure getpos;
     var i:byte;
     begin
      mssetpos(x,y);
      repeat
       msgetbut(i);
      until i and $7>0;
      msgetpos(x,y);
     end;
    begin
     fillchar(buts,sizeof(buts),0);
     butcount:=0;
     regs.ax:=0;
     msintr;
     if regs.ax=0 then msinit:=false else msinit:=true;
     visible:=false;
    end.
